/*
*	WGAppDelegate.h
*		・AppDelegate
*		・アプリの振る舞いを決定します。  
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import <Cocoa/Cocoa.h>

#define kWGNowStartDownloadNotification			@"WGNowStartDownloadNotification"
#define kWGNowTerminateDownloadNotification		@"WGNowTerminateDownloadNotification"
#define kWGOpenLocationDropedNotification		@"WGOpenLocationDropedNotification"
#define kWGGiveMeOpenLocationNotification		@"WGGiveMeOpenLocationNotification"

#define kWGOpenLocationKey				@"WGOpenLocationKey"

@interface WGAppDelegate : NSObject
{
    int			mDownloadingNum;
    
    BOOL		mOpenDropItem;
    BOOL		mAppLaunched;
    NSMutableString*	mLocationPath;
    NSDictionary*	mLocationPathDictionary;
}

// 初期化と解放 
- (id)init;
- (void)dealloc;

// NSApplication's delegate
- (NSApplicationTerminateReply) applicationShouldTerminate : (NSApplication *)sender;
- (BOOL)application : (NSApplication *)sender openFile : (NSString *)filename;
- (BOOL)application:(NSApplication *)sender openTempFile:(NSString *)filename;
- (void)applicationDidFinishLaunching : (NSNotification *)notification;

// Notification 
- (void)nowStartDownload : (NSNotification *)inNotification;
- (void)nowTerminateDownload : (NSNotification *)inNotification;
- (void)giveMeOpenLocation : (NSNotification *)inNotification;

@end
