/*
*	WGPrefOthrDontDownTableView.m
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import "WGPrefOthrDontDownTableView.h"

@implementation WGPrefOthrDontDownTableView
static int intDeSort(id num1, id num2, void *context);

/*===================================
    keyDown
=====================================*/
- (void)keyDown : (NSEvent *)inEvent
{
    NSString*		theKeyString;
    unichar  		theKeyChar;
    NSEnumerator*	theSelectedRowEnumerator;
    NSArray*		theSelectedRowArray;
    NSEnumerator*	theSortedSelectedRowEnumerator;
    NSArray*		theSortedSelectedRowArray;
    NSNumber*		theSelectedRowNumber;

   theKeyString = [ inEvent charactersIgnoringModifiers ];
   theKeyChar = [ theKeyString characterAtIndex : 0 ];

    switch( theKeyChar ) {
	case 0177:	// ꂪ炵 
	case NSDeleteFunctionKey:
	case NSDeleteCharFunctionKey:
	    theSelectedRowEnumerator = [ self selectedRowEnumerator ];
	    theSelectedRowArray = [ theSelectedRowEnumerator allObjects ];
	    theSortedSelectedRowArray = [ theSelectedRowArray sortedArrayUsingFunction : intDeSort context : NULL ];
	    theSortedSelectedRowEnumerator = [ theSortedSelectedRowArray objectEnumerator ];
	    while ( ( theSelectedRowNumber = [ theSortedSelectedRowEnumerator nextObject ] ) != nil ) {
		[ [self dataSource] tableView : (NSTableView *)self
			       setObjectValue : @""
			       forTableColumn : [ self tableColumnWithIdentifier : kDontDownloadIdentifier ]
					  row : [ theSelectedRowNumber intValue ] ];
	    }
	break;
	default:
	    [ super keyDown : inEvent ];
	break;
    }
}

/*===================================
    setDontDownloadTableData 
=====================================*/
-(void)setDontDownloadTableData : (NSArray*) inData
{
    [ [ self dataSource ] setDontDownloadTableData : inData ];
}

/*===================================
    dontDownloadTableData
=====================================*/
-(NSArray*)dontDownloadTableData
{
    return [ [ self dataSource ] dontDownloadTableData ];
}
/*===================================
    intDeSort ~ 
=====================================*/
static int intDeSort(id num1, id num2, void *context)
{
    int v1 = [num1 intValue];
    int v2 = [num2 intValue];
    if (v1 < v2)
        return NSOrderedDescending;
    else if (v1 > v2)
        return NSOrderedAscending;
    else
        return NSOrderedSame;
}
	
@end
