/*
*	WGPreference.m
*
*  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
*/
#import "WGPreference.h"

static WGPreference*	sharedWGPreferenceInstance = nil;	// O蒼ځAQƂȂB 

@implementation WGPreference

/*===================================
     
=====================================*/
- (id)init
{
    NSUserDefaults* 	theUserDefaults = [ NSUserDefaults standardUserDefaults ];

    isFirstShow = YES;
    mStateChangeFlag = 0;
    
    if ( !sharedWGPreferenceInstance ) {
        [ super init ];

	// AvI󂯎 
        [ [ NSNotificationCenter defaultCenter ] addObserver : self 
						    selector : @selector( getNSApplicationWillTerminateNotification : ) 
							name : NSApplicationWillTerminateNotification 
						      object : nil ];
	
        sharedWGPreferenceInstance = self;
	mPreferenceDownloadDictionary = [ [ NSMutableDictionary alloc ] initWithCapacity : 10 ];
	mPreferenceLogDictionary = [ [ NSMutableDictionary alloc ] initWithCapacity : 10 ];
	mPreferenceOtherDictionary = [ [ NSMutableDictionary alloc ] initWithCapacity : 10 ];
	
	
	if ( ![ self existUserDefaults ] ) {
	    [ self makeUserDefaults ];
	    [ self saveUserDefaults ];
	} else {
	    [ mPreferenceDownloadDictionary setDictionary : [ theUserDefaults dictionaryForKey : kPreferenceDownloadDictionaryKey ] ];
	    [ mPreferenceLogDictionary setDictionary : [ theUserDefaults dictionaryForKey : kPreferenceLogDictionaryKey ] ];
	    [ mPreferenceOtherDictionary setDictionary : [ theUserDefaults dictionaryForKey : kPreferenceOtherDictionaryKey ] ];
	}
    }

    return sharedWGPreferenceInstance;
}
/*================================
    nib[h̏ 
==================================*/
- (void) awakeFromNib
{
    if ( WGPreferenceDownloadController ) [ (id <WGPreferenceController>)WGPreferenceDownloadController initValuesWithDictionary : mPreferenceDownloadDictionary ];
    if ( WGPreferenceLogController ) [ (id <WGPreferenceController>)WGPreferenceLogController initValuesWithDictionary : mPreferenceLogDictionary ];
    if ( WGPreferenceOtherController ) [ (id <WGPreferenceController>)WGPreferenceOtherController initValuesWithDictionary : mPreferenceOtherDictionary ];
}

/*===================================
    dealloc 
=====================================*/
- (void)dealloc
{   
    [ WGPreferenceDownloadController release ];
    [ WGPreferenceLogController release ];
    [ WGPreferenceOtherController release ];

    [ mPreferenceDownloadDictionary release ];
    [ mPreferenceLogDictionary release ];
    [ mPreferenceOtherDictionary release ];
    
    [ [ NSNotificationCenter defaultCenter ] removeObserver : self ];

    [ super dealloc ];
}

/*===================================
    Window\  
=====================================*/
- (void)showWindow : (id)sender
{
    if ( !sharedWGPreferenceInstance ) {
	return;
    }
    if ( isFirstShow && ![ NSBundle loadNibNamed : kPreferenceNibName owner : self ] )  {
	return;
    }

    isFirstShow = NO;
    
    [ _window setFloatingPanel : YES ];
    [ _window makeKeyAndOrderFront : nil ];
}

/*===================================
    ݒ肪ω (Protocol WGPreference)  
=====================================*/
- (void)changeValue : (id)sender
{
    if ( sender == WGPreferenceDownloadController ) mStateChangeFlag |= kDownloadChange;
    else if ( sender == WGPreferenceLogController ) mStateChangeFlag |= kLogChange;
    else if ( sender == WGPreferenceOtherController ) mStateChangeFlag |= kOtherChange;

    [ _save setEnabled : YES ];
}

/*===================================
    ݒ肪ωĂȂ (Protocol WGPreference)   
=====================================*/
- (void)unchangeValue : (id)sender
{
    if ( sender == WGPreferenceDownloadController ) mStateChangeFlag &= ~kDownloadChange;
    else if ( sender == WGPreferenceLogController ) mStateChangeFlag &= ~kLogChange;
    else if ( sender == WGPreferenceOtherController ) mStateChangeFlag &= ~kOtherChange;

    if ( 0 == mStateChangeFlag ) [ _save setEnabled : NO ];
} 

/*===================================
    pushCancelButton    
=====================================*/
- (IBAction)pushCancelButton : (id)sender
{
    [ _window performClose : sender ];
    [ (id <WGPreferenceController>)WGPreferenceDownloadController resetValuesWithDictionary : mPreferenceDownloadDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceLogController resetValuesWithDictionary : mPreferenceLogDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceOtherController resetValuesWithDictionary : mPreferenceOtherDictionary ];
    [ _save setEnabled : NO ];
}

/*===================================
    pushDefaultButton    
=====================================*/
- (IBAction)pushDefaultButton : (id)sender
{
    [ self makeUserDefaults ];
    [ self saveUserDefaults ];
    [ (id <WGPreferenceController>)WGPreferenceDownloadController initValuesWithDictionary : mPreferenceDownloadDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceLogController initValuesWithDictionary : mPreferenceLogDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceOtherController initValuesWithDictionary : mPreferenceOtherDictionary ];
    [ _save setEnabled : NO ];
}

/*===================================
    pushOkButton    
=====================================*/
- (IBAction)pushOkButton : (id)sender
{
    [ _window performClose : self ];
    [ self save ];
    [ (id <WGPreferenceController>)WGPreferenceDownloadController initValuesWithDictionary : mPreferenceDownloadDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceLogController initValuesWithDictionary : mPreferenceLogDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceOtherController initValuesWithDictionary : mPreferenceOtherDictionary ];
    [ _save setEnabled : NO ];
}

/*===================================
    pushSaveButton    
=====================================*/
- (IBAction)pushSaveButton : (id)sender
{
    [ self save ];
    [ (id <WGPreferenceController>)WGPreferenceDownloadController initValuesWithDictionary : mPreferenceDownloadDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceLogController initValuesWithDictionary : mPreferenceLogDictionary ];
    [ (id <WGPreferenceController>)WGPreferenceOtherController initValuesWithDictionary : mPreferenceOtherDictionary ];
    [ _save setEnabled : NO ];
}

/*===================================
    existUserDefaults   UserDefaults݂邩H 
=====================================*/
- (BOOL)existUserDefaults
{
    NSUserDefaults* 	theUserDefaults;
    NSNumber*		theWGUserDefaultVersion;
    BOOL		theExistUserDefaults = YES;
    NSDictionary*	theTemp1;
    NSDictionary*	theTemp2;
    NSDictionary*	theTemp3;

    theUserDefaults = [ NSUserDefaults standardUserDefaults ];
    theWGUserDefaultVersion = [ theUserDefaults objectForKey : kWGUserDefaultVersionKey ];	// o[W`FbNB 
//    if ( (nil == theWGUserDefaultVersion) || ![ theWGUserDefaultVersion isEqual : kDefaultWGUserDefaultVersionValue ] ) {
    if ( (nil == theWGUserDefaultVersion) || ([ theWGUserDefaultVersion floatValue] < [ kDefaultWGUserDefaultVersionValue floatValue]) ) {	// 0.2
	theExistUserDefaults = NO;
    } else {
	theTemp1 = [ theUserDefaults dictionaryForKey : kPreferenceDownloadDictionaryKey];
	theTemp2 = [ theUserDefaults dictionaryForKey : kPreferenceLogDictionaryKey];
	theTemp3 = [ theUserDefaults dictionaryForKey : kPreferenceOtherDictionaryKey];
	if ( !theTemp1 || !theTemp2 || !theTemp3 ) {
	    theExistUserDefaults = NO;
	}
    }
    
    return theExistUserDefaults;
}

/*===================================
    makeUserDefaults [U[ݒ肪Ȃꍇ̐ݒB   
=====================================*/
- (void)makeUserDefaults
{
    NSDictionary*	theTempPrefDownloadDict;
    NSDictionary*	theTempPrefLogDict;
    NSDictionary*	theTempPrefOtherDict;

    theTempPrefDownloadDict = [ NSDictionary dictionaryWithObjectsAndKeys : 
						    [ NSNumber numberWithInt : kDefaultPreference_d_RetryValue ], kPreference_d_RetryKey,
						    [ NSNumber numberWithInt : kDefaultPreference_d_TimeOutNumValue ], kPreference_d_TimeOutNumKey,
						    kDefaultPreference_d_TimeOutUnitValue, kPreference_d_TimeOutUnitKey,
						    [ NSNumber numberWithBool : kDefaultPreference_d_ContentLengthValue ], kPreference_d_ContentLengthKey,
						    [ NSNumber numberWithInt : kDefaultPreference_d_WaitTimeValue ], kPreference_d_WaitTimeKey,
						    kDefaultPreference_d_WaitTimeUnitValue, kPreference_d_WaitTimeUnitKey,
						    [ NSNumber numberWithBool : kDefaultPreference_d_UseServerCashValue ], kPreference_d_UseServerCashKey,
						    kDefaultPreference_d_SaveLocationValue, kPreference_d_SaveLocationKey,
						    kDefaultPreference_d_MakeFolderValue, kPreference_d_MakeFolderKey,
						    [ NSNumber numberWithBool : kDefaultPreference_d_MakeFolderByHostNameValue ], kPreference_d_MakeFolderByHostNameKey,
						    [ NSNumber numberWithInt : kDefaultPreference_d_OmitFolderValue ], kPreference_d_OmitFolderKey,
						    nil ];
    [ mPreferenceDownloadDictionary setDictionary : theTempPrefDownloadDict ];

    theTempPrefLogDict = [ NSDictionary dictionaryWithObjectsAndKeys : 
						    [ NSNumber numberWithInt : kDefaultPreference_l_LogLevelValue ], kPreference_l_LogLevelKey,
						    kDefaultPreference_l_LogStyleValue, kPreference_l_LogStyleKey,
						    [ NSNumber numberWithBool : kDefaultPreference_l_OutputLogFileValue ], kPreference_l_OutputLogFileKey,
						    kDefaultPreference_l_OutputLogFileTypeValue, kPreference_l_OutputLogFileTypeKey,
						    kDefaultPreference_l_OutputLogFileLocationValue, kPreference_l_OutputLogFileLocationKey,
						    [ NSNumber numberWithInt : kDefaultPreference_l_LogFileCapacityValue ], kPreference_l_LogFileCapacityKey,
						    nil ];
    [ mPreferenceLogDictionary setDictionary : theTempPrefLogDict ];

    theTempPrefOtherDict = [ NSDictionary dictionaryWithObjectsAndKeys : 
						    [ NSNumber numberWithBool : kDefaultPreference_o_DNSLookUpValue ], kPreference_o_DNSLookUpKey,
						    [ NSNumber numberWithBool : kDefaultPreference_o_OnlyCheakValue ], kPreference_o_OnlyCheakKey,
						    [ NSNumber numberWithBool : kDefaultPreference_o_UsePassiveModeValue ], kPreference_o_UsePassiveModeKey,
						    [ NSNumber numberWithBool : kDefaultPreference_o_UseProxyValue ], kPreference_o_UseProxyKey,
						    kDefaultPreference_o_ProxyIPAdressValue, kPreference_o_ProxyIPAdressKey,
						    kDefaultPreference_o_ProxyPortValue, kPreference_o_ProxyPortKey,
						    kDefaultPreference_o_DontGetArrayValue, kPreference_o_DontGetArrayKey,
						    nil ];
    [ mPreferenceOtherDictionary setDictionary : theTempPrefOtherDict ];
}

/*===================================
    saveUserDefaults    
=====================================*/
- (void)saveUserDefaults
{
    NSUserDefaults* 	theUserDefaults;
    
    theUserDefaults = [ NSUserDefaults standardUserDefaults ];
    
    [ theUserDefaults removeObjectForKey : kWGUserDefaultVersionKey ];
    [ theUserDefaults removeObjectForKey : kPreferenceDownloadDictionaryKey ];
    [ theUserDefaults removeObjectForKey : kPreferenceLogDictionaryKey ];
    [ theUserDefaults removeObjectForKey : kPreferenceOtherDictionaryKey ];
    
    [ theUserDefaults setObject : kDefaultWGUserDefaultVersionValue
			 forKey : kWGUserDefaultVersionKey ];
    [ theUserDefaults setObject : mPreferenceDownloadDictionary
			 forKey : kPreferenceDownloadDictionaryKey ];
    [ theUserDefaults setObject : mPreferenceLogDictionary
			 forKey : kPreferenceLogDictionaryKey ];
    [ theUserDefaults setObject : mPreferenceOtherDictionary
			 forKey : kPreferenceOtherDictionaryKey ];
    
}

/*===================================
    save    
=====================================*/
- (void)save
{
    [ mPreferenceDownloadDictionary setDictionary : [ WGPreferenceDownloadController dictionaryValues ] ];
    [ mPreferenceLogDictionary setDictionary : [ WGPreferenceLogController dictionaryValues ] ];
    [ mPreferenceOtherDictionary setDictionary : [ WGPreferenceOtherController dictionaryValues ] ];

    [ self saveUserDefaults ];
}


/*===================================
    getNSApplicationWillTerminateNotification    
=====================================*/
- (void)getNSApplicationWillTerminateNotification : (NSNotification *)inNotification
{
    // ځAdeallocbZ[W𑗂Ă悢B 
    //[ self dealloc ];
    [ self autorelease ];
}

/*===================================
    preferenceArgs    
=====================================*/
- (NSArray*)preferenceArgs
{
    NSMutableArray*	theArgs = [ NSMutableArray array ];
    NSMutableString* 	theTempString;
    NSMutableString* 	theTempString2;
    NSMutableString* 	theTempString3;
    BOOL		theBoolValue;
    int			theIntValue;
    NSMutableArray*	theArray;
    NSEnumerator*	theEnumerator;

    // s 
    theIntValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_RetryKey ] intValue ];
    theTempString = [ NSMutableString stringWithFormat : @"%@%d", kWGRetryOption, theIntValue ];
    [ theArgs addObject : theTempString ];
    // ^CAEg 
    theIntValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_TimeOutNumKey ] intValue ];
    theTempString2 = [ mPreferenceDownloadDictionary objectForKey : kPreference_d_TimeOutUnitKey ];
    theTempString = [ NSMutableString stringWithFormat : @"%@%d%@", kWGTimeOutOption, theIntValue, theTempString2 ];
    [ theArgs addObject : theTempString ];
    // ContentLength 
    theBoolValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_ContentLengthKey ] boolValue ];
    if ( theBoolValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGIgnoreLengthOption ];
	[ theArgs addObject : theTempString ];
    }
    // ҂ 
    theIntValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_WaitTimeKey ] intValue ];
    theTempString2 = [ mPreferenceDownloadDictionary objectForKey : kPreference_d_WaitTimeUnitKey ];
    theTempString = [ NSMutableString stringWithFormat : @"%@%d%@", kWGWaitTimeOption, theIntValue, theTempString2 ];
    [ theArgs addObject : theTempString ];
    // T[oLbV𗘗p 
    theBoolValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_UseServerCashKey ] boolValue ];
    if ( theBoolValue ) theTempString = [ NSMutableString stringWithFormat : @"%@=%@", kWGUseServerCasheOption, kWGOptionON ];
    else theTempString = [ NSMutableString stringWithFormat : @"%@=%@", kWGUseServerCasheOption, kWGOptionOFF ];
    [ theArgs addObject : theTempString ];
    // ۑ 
    theTempString2 = [ mPreferenceDownloadDictionary objectForKey : kPreference_d_SaveLocationKey ];
    theTempString = [ NSMutableString stringWithFormat : @"%@%@", kWGSaveLocationOption, theTempString2 ];
    [ theArgs addObject : theTempString ];
    // tH_̍쐬 
    theTempString2 = [ mPreferenceDownloadDictionary objectForKey : kPreference_d_MakeFolderKey ];
    if ( [ theTempString2 isEqualToString : kWGStateMakeFolderDontMake ] ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGNoDirectoriesOption ];
	[ theArgs addObject : theTempString ];
    } else if ( [ theTempString2 isEqualToString : kWGStateMakeFolderAlways ] ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGForceMakeDirectoriesOption ];
	[ theArgs addObject : theTempString ];
    } else if ( [ theTempString2 isEqualToString : kWGStateMakeFolderNormal ] ) {
	// Do Nothing.
    }
    // zXgɂtH_쐬 
    theBoolValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_MakeFolderByHostNameKey ] boolValue ];
    if ( !theBoolValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGDontMakeHostNameFolderOption ];
	[ theArgs addObject : theTempString ];
    }
    // tH_쐬ȗ 
    theIntValue = [ [ mPreferenceDownloadDictionary objectForKey : kPreference_d_OmitFolderKey ] intValue ];
    if ( theIntValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@=%d", kWGOmitMakingFolderOption, theIntValue ];
	[ theArgs addObject : theTempString ];
    }
    
    // Ox 
    theIntValue = [ [ mPreferenceLogDictionary objectForKey : kPreference_l_LogLevelKey ] intValue ];
    if ( kWGStateLogLevel1 == theIntValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGQuietLogOption ];
	[ theArgs addObject : theTempString ];
    } else if ( kWGStateLogLevel2 == theIntValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGNoVerbaseLogOption ];
	[ theArgs addObject : theTempString ];
    } else if ( kWGStateLogLevel3 == theIntValue ) {
	// Do nothing. (Default)
    } else if ( kWGStateLogLevel4 == theIntValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGDebugLogOption ];
	[ theArgs addObject : theTempString ];
    } else if ( kWGStateLogLevel5 == theIntValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGDebugLogOption ];
	[ theArgs addObject : theTempString ];
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGServerResponseLogOption ];
	[ theArgs addObject : theTempString ];
    }
    // OX^C  
    theTempString2 = [ mPreferenceLogDictionary objectForKey : kPreference_l_LogStyleKey ];
    theTempString = [ NSMutableString stringWithFormat : @"%@=%@", kWGLogStyleOption, theTempString2 ];
    [ theArgs addObject : theTempString ];
    // Ot@Cɏo(GȂ̂ŁAӁB) 
    theBoolValue = [ [ mPreferenceLogDictionary objectForKey : kPreference_l_OutputLogFileKey ] boolValue ];
    if ( theBoolValue ) {
	theTempString2 = [ mPreferenceLogDictionary objectForKey : kPreference_l_OutputLogFileTypeKey ];
	if ( [ theTempString2 isEqualToString : kWGStateLogFileTypeOverwrite ] ) {
	    theTempString2 = [ mPreferenceLogDictionary objectForKey : kPreference_l_OutputLogFileLocationKey ];
	    theTempString = [ NSMutableString stringWithFormat : @"%@%@/%@", kWGLogOverwriteOption, theTempString2, kLogFileName ];
	    [ theArgs addObject : theTempString ];
	} else if ( [ theTempString2 isEqualToString : kWGStateLogFileTypeAppend ] ) {
	    theTempString2 = [ mPreferenceLogDictionary objectForKey : kPreference_l_OutputLogFileLocationKey ];
	    theTempString = [ NSMutableString stringWithFormat : @"%@%@/%@", kWGLogAppendOption, theTempString2, kLogFileName ];
	    [ theArgs addObject : theTempString ];
	}
	
    }

    // DNSbNAbvȂ 
    theBoolValue = [ [ mPreferenceOtherDictionary objectForKey : kPreference_o_DNSLookUpKey ] boolValue ];
    if ( theBoolValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGDontLookUpDNSOption ];
	[ theArgs addObject : theTempString ];
    }
    // `FbN̂ 
    theBoolValue = [ [ mPreferenceOtherDictionary objectForKey : kPreference_o_OnlyCheakKey ] boolValue ];
    if ( theBoolValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGOnlyCheakOption ];
	[ theArgs addObject : theTempString ];
    }
    // FTP passive[h  
    theBoolValue = [ [ mPreferenceOtherDictionary objectForKey : kPreference_o_UsePassiveModeKey ] boolValue ];
    if ( theBoolValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGFTPPassiveModeOption ];
	[ theArgs addObject : theTempString ];
    }
    // Proxy
    theBoolValue = [ [ mPreferenceOtherDictionary objectForKey : kPreference_o_UseProxyKey ] boolValue ];
    if ( theBoolValue ) {
	theTempString = [ NSMutableString stringWithFormat : @"%@=%@", kWGUseProxyOption, kWGOptionON ];
	[ theArgs addObject : theTempString ];
	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGOptionExecute ];
	[ theArgs addObject : theTempString ];
	theTempString2 = [ mPreferenceOtherDictionary objectForKey : kPreference_o_ProxyIPAdressKey ];
	theTempString3 = [ mPreferenceOtherDictionary objectForKey : kPreference_o_ProxyPortKey ];
	theTempString = [ NSMutableString stringWithFormat : @"%@=%@:%@", kWGHTTPProxyOption, theTempString2, theTempString3 ];
	[ theArgs addObject : theTempString ];
    } else {
	theTempString = [ NSMutableString stringWithFormat : @"%@=%@", kWGUseProxyOption, kWGOptionOFF ];
	[ theArgs addObject : theTempString ];
    }
    // 擾Xg 
    theArray = [ mPreferenceOtherDictionary objectForKey : kPreference_o_DontGetArrayKey ];
    if ( [ theArray count ] ) {
	NSMutableString*	theMutableString = [ [ NSMutableString alloc ] initWithCapacity : 10 ];

	theTempString = [ NSMutableString stringWithFormat : @"%@", kWGRejectOption ];
	[ theArgs addObject : theTempString ];
	//[ theArgs addObject : @"" ];		// 󔒂ׁB 

	theEnumerator = [ theArray objectEnumerator ];
	theTempString2 = [ theEnumerator nextObject ];
	if ( theTempString2 && ![ theTempString2 isEqualToString : @"" ] ) {
	    [ theMutableString appendString : theTempString2 ];
	}
	while ( ( theTempString2 = [ theEnumerator nextObject ] ) != nil ) {
	    if ( ![ theTempString2 isEqualToString : @"" ] ) {
		[ theMutableString appendFormat : @"%@%@", @",", theTempString2 ];
	    }
	}
	[ theArgs addObject : theMutableString ];
	[ theMutableString autorelease ];
    }

    return	theArgs;
}

@end
