/*
 *	WGWetsCmdWrappar.h
 *		・wgetとプロセス間通信を行い、結果をWindowControllerに返す。 
 *
 *  Copyright (c) 2001- Tomonori Tomatsu. All rights reserved.
 *
 *  修正履歴
 *  0.20a2
 *  2002/03/25 wgetのoutputの読み方を、Timerベースから、
 *             NSFileHandleのNSFileHandleReadCompletionNotificationベースで、取得するようにした。（Apple社のサンプルMoriarityを参考。） 
 *
 */
#import <Cocoa/Cocoa.h>

#import "WGWindowController.h"

@interface WGWetsCmdWrappar : NSObject
{
    IBOutlet id		mWindowCtlr;

    BOOL		mNowDownloading;
    NSMutableArray*	mArgs;
    NSTask*		mTask;
    NSPipe*		mPipe;
    NSFileHandle* 	mReadHandle;
}

// 初期化と解放 
- (id)init;
- (void)dealloc;

// インターフェイスと実装 
- (BOOL)startDownload : (NSMutableArray*)inArgs;
- (void)stopDownload;

// 局所メソッド 
- (void)seeOutput;

// NSTask's Notification
- (void)checkTerminationStatus : (NSNotification *)inNotification;
// NSFileHandle's Notification
- (void)getData : (NSNotification *)inNotification;

- (long) systemVersion;
@end
